PRELOAD=$1
REDBOOT=$2
HWCONFIG=$3
LOGO=$4
EPSON_INSTRUCTION=$5
EPSON_WAVEFORM=$6
KERNEL=$7
DEVICE=$8
UBOOT=$9

zcat /etc/images/one_moment_please.raw.gz | /usr/local/Kobo/pickel showpic

if [ -e $PRELOAD ]; then
	echo Upgrading preloader $PRELOAD
	dd if=$PRELOAD of=/dev/$DEVICE bs=512 count=1
	dd if=$PRELOAD of=/dev/$DEVICE bs=512 count=1 seek=2 skip=2
	if [ $? != 0 ] ; then
		zcat /etc/images/error_preloader.raw.gz | /usr/local/Kobo/pickel showpic
		exit 1
	fi
	sync
	sync
	echo Done upgrading preloader
fi

if [ -e $UBOOT ]; then
	echo Upgrading U-Boot $UBOOT
	dd if=$UBOOT of=/dev/$DEVICE bs=512 seek=256
	if [ $? != 0 ] ; then
		zcat /etc/images/error_redboot.raw.gz | /usr/local/Kobo/pickel showpic
		exit 1
	fi
	sync
	sync
	echo Done upgrading $UBOOT
fi

if [ -e $REDBOOT ]; then
	echo Upgrading Redboot $REDBOOT
	dd if=$REDBOOT of=/dev/$DEVICE bs=512 seek=2 skip=2
	if [ $? != 0 ] ; then
		zcat /etc/images/error_redboot.raw.gz | /usr/local/Kobo/pickel showpic
		exit 1
	fi
	sync
	sync
	echo Done upgrading Redboot
fi

if [ -e $HWCONFIG ]; then
	echo Upgrading Hardware Configuration $HWCONFIG
	dd if=$HWCONFIG of=/dev/$DEVICE bs=512 seek=1024
	if [ $? != 0 ] ; then
		zcat /etc/images/error_hwconfig.raw.gz | /usr/local/Kobo/pickel showpic
		exit 1
	fi
	sync
	sync
	echo Done upgrading Hardware Configuration
fi

if [ -e $LOGO ]; then
	echo Upgrading Logo $LOGO
	dd if=$LOGO of=/dev/$DEVICE bs=512 seek=1026
	if [ $? != 0 ] ; then
		zcat /etc/images/error_logo.raw.gz | /usr/local/Kobo/pickel showpic
		exit 1
	fi
	sync
	sync
	echo Done upgrading Logo
fi

if [ -e $EPSON_INSTRUCTION ]; then
	echo Upgrading Epson Instruction $EPSON_INSTRUCTION
	dd if=$EPSON_INSTRUCTION of=/dev/$DEVICE bs=512 seek=1920
	if [ $? != 0 ] ; then
		zcat /etc/images/error_epson_instruction.raw.gz | /usr/local/Kobo/pickel showpic
		exit 1
	fi
	sync
	sync
	echo Done upgrading Epson Instruction
fi

if [ -e $EPSON_WAVEFORM ]; then
	echo Upgrading Epson Waveform $EPSON_WAVEFORM
	dd if=$EPSON_WAVEFORM of=/dev/$DEVICE bs=512 seek=1928
	if [ $? != 0 ] ; then
		zcat /etc/images/error_epson_waveform.raw.gz | /usr/local/Kobo/pickel showpic
		exit 1
	fi
	sync
	sync
	echo Done upgrading Epson Waveform
fi

if [ -e $KERNEL ]; then
	echo Upgrading kernel... $KERNEL
	dd if=$KERNEL of=/dev/$DEVICE bs=512 seek=2048
	if [ $? != 0 ]; then
		zcat /etc/images/error_kernel.raw.gz | /usr/local/Kobo/pickel showpic
		exit 1
	fi
	sync
	sync
	echo Done upgrading kernel...
fi
